#include "DateTimeDisplayPane.h"

DateTimeDisplayPane* DateTimeDisplayPane::CreateDateTimeDisplayPaneStream(LStream *inStream)
{
	return new DateTimeDisplayPane ( inStream );
}
	
DateTimeDisplayPane::DateTimeDisplayPane()
{
}

DateTimeDisplayPane::DateTimeDisplayPane(const LCaption &inOriginal) :
	LCaption ( inOriginal )
{
}

DateTimeDisplayPane::DateTimeDisplayPane( const SPaneInfo	&inPaneInfo,
								ResIDT			inTextTraitsID ) :
	LCaption ( inPaneInfo, "\p", inTextTraitsID )
{
}

DateTimeDisplayPane::DateTimeDisplayPane(LStream *inStream) :
	LCaption ( inStream )
{
}
	
DateTimeDisplayPane::~DateTimeDisplayPane()
{
}

void DateTimeDisplayPane::DrawSelf ( )
{	Str255	dateTimeStr;
	
	GetDescriptor ( mText );
	LCaption::DrawSelf ( );	
}

void DateTimeDisplayPane::GetDescriptor ( Str255	outDescriptor ) const
{	LStr255 timeStr;

	DateString ( GetValue(), shortDate, outDescriptor, nil );
	IUTimePString ( GetValue(), false, timeStr, nil );
	
	LString::AppendPStr ( outDescriptor, "\p " );
	LString::AppendPStr ( outDescriptor, timeStr );
}

Int32 DateTimeDisplayPane::GetValue() const
{
	return mDateTimeSecs;
}

void DateTimeDisplayPane::SetDescriptor (ConstStringPtr inDescriptor)
{
	SignalPStr_("\pSetDescriptor undefined");
}

void DateTimeDisplayPane::SetValue( Int32			inValue)
{
	if ( inValue != GetValue() )
		Refresh();
	mDateTimeSecs = inValue;
}	
