
#include <QuickTimeComponents.h>

#include <LPane.h>
#include <LPeriodical.h>
#include <LView.h>

class SequenceGrabberPane : public LView, LPeriodical {
public:
	enum { class_ID = 'Grab' };
	static SequenceGrabberPane*		CreateSequenceGrabberPaneStream(LStream *inStream);
	
						SequenceGrabberPane();
						SequenceGrabberPane(const SequenceGrabberPane &inOriginal);		
						// SequenceGrabberPane(const SSequenceGrabberPaneInfo &inSequenceGrabberPaneInfo);
						SequenceGrabberPane(LStream *inStream);
	
	virtual				~SequenceGrabberPane();

	virtual void		DoSetupDialog ( );

	virtual void		DrawSelf ( );
	
	virtual void		FinishCreate();

	virtual void		Grab ( );

	virtual void		ResizeFrameBy(Int16 inWidthDelta, Int16 inHeightDelta,
									Boolean inRefresh);

	virtual void		SetLiveUpdate ( Boolean newValue );
	
	virtual	void		SpendTime( const EventRecord		&inMacEvent);

	Handle				GetConfiguration () const;
	void				SetConfiguration ( Handle h );

protected:
	void				InitializeSequenceGrabber ( );
	void				SetUpdateDirectToScreen ( );
	
	Boolean fQuickTime, fSequenceGrabber;
	LGWorld*			mGWorld;
	// GWorldPtr fOffscreenWorld;
	// PixMapHandle fOffscreenPixMap;
	// Rect fOffscreenRect;
	Rect 				mSourceVideoBounds;
	
	SeqGrabComponent 	fSequenceGrabberComponent;
	SGChannel 			fVideoChannel;
	
	Boolean			mLiveUpdate;
};