// ===========================================================================
//	VideoFolderWindow.h				   
// ===========================================================================

#pragma once

#include <LListener.h>
#include <LPeriodical.h>
#include <LWindow.h>
#include <UGWorld.h>

#include "ConvertToFinderIconPict.h"

enum {
	cmd_GrabFrame = 4000,
	cmd_SequenceGrabberSetup = 4001,
	cmd_LiveUpdateControl = 4005,
	cmd_GrabInterval = 4010,
	cmd_SetDestination = 4020 };
	

class	VideoFolderWindow : public LWindow, LListener, LPeriodical {
public:
	enum { class_ID = 'VFol' };
	static VideoFolderWindow*		CreateVideoFolderWindowStream(LStream *inStream);

						VideoFolderWindow( LStream* inStream);
	virtual				~VideoFolderWindow();

	virtual void		DoGrab ( );
	virtual void		DoSequenceGrabberSetup();

	virtual void		FindCommandStatus(
								CommandT	inCommand,
								Boolean		&outEnabled,
								Boolean		&outUsesMark,
								Char16		&outMark,
								Str255		outName);

	virtual void		FinishCreate ( );

	virtual unsigned long	GetUpdateInterval ( ) const;
	virtual void 			SetUpdateInterval ( unsigned long interval );

	virtual Boolean		HandleKeyPress( const EventRecord	&inKeyEvent);

	virtual void		ListenToMessage(
							MessageT		inMessage,
							void			*ioParam);

	virtual Boolean 	ObeyCommand( CommandT			inCommand,
								void				*ioParam );

	virtual	void	SpendTime( const EventRecord		&inMacEvent);

protected:
	LDefaultOutline*			mDefaultOutline;

	class SequenceGrabberPane*	mSequenceGrabberPane;
	// CFinderIconPicture*			mFinderIconPicture;
	
	class LPane*				mNextUpdateControl;
	class LStdPopupMenu*		mUpdateIntervalControl;
	
	// FSSpec						mDestinationSpec;
};
